<?
  require(dirname(__FILE__) . '/config.inc.php');

  //callback ,  
  function mirror_smart_replace_callback($m)
  {
    global $mirror_http_base;
    global $mirror_cfg;
    $cfg = $mirror_cfg;
    $uri = $cfg['uri'];

    // `` 
    $abs = mirror_rel2abs($m[1], $mirror_http_base);

    $ret = $m[0];

    ///         uri
    $count_uri = count($uri);
    for($i = 0; $i < $count_uri; $i++)
    {
      $res = strstr($abs, $cfg['domain'] . $uri[$i]);

      if($res !== false)
      {
        $ret = str_replace($m[1], $abs, $m[0]);
        break;
      }
    }
    //end

    return $ret;
  }
  //end

  //   parse_url
  function mirror_parse_url($str)
  {
    $pu = @parse_url($str);

    //  query (   ?,     )
    if(!isset($pu['query']))
    {
      list($tmp, $q) = split('\?', $str, 2);

      if(isset($q))
        $pu['query'] = '';
    }
    //end

    //  fragment (   #,     )
    if(!isset($pu['fragment']))
    {
      list($tmp, $f) = split('#', $str, 2);

      if(isset($f))
        $pu['fragment'] = '';
    }
    //end

    return $pu;
  }
  //end

  //    
  function mirror_rel2abs($url, $base, $fragment_add = 1)
  {
    $pu = mirror_parse_url($url);

    //   ,     ``
    if(!isset($pu['scheme']))
    {
      $pu_base = mirror_parse_url($base);

      if(isset($pu_base['scheme']))
        $tmp = $pu_base['scheme']; else
        $tmp = 'http://';
      $tmp .= '://' . $pu_base['host'];

      if(isset($pu_base['port']))
        $tmp .= ':' . $pu_base['port'];

      //    , /
      if($url[0] === '/')
      {
        $url .= $tmp;
      } else
      {
        $last_slash_pos = strrpos($pu_base['path'], '/') + 1;
        $web_dirname = substr($pu_base['path'], 0, $last_slash_pos);
        $url = $tmp . $web_dirname . $url;
      }
      //end

      $pu = mirror_parse_url($url);
    }
    //end

    $pu_path = $pu['path'];

    // /./  /
    $pu_path = str_replace('/./', '/', $pu_path);
    //end

    //  /
    $sl = split('/', $pu_path);
    //end

    // '..'
    for($i = 0; $i < count($sl); $i++)
    {
      if($sl[$i] == '..')
      {
        $skip[$i] = 1;

        //     
        for($j = ($i - 1); $j >= 0; $j--)
        {
          if( (isset($skip[$j])) && ($skip[$j] === 0) )
          {
            $skip[$j] = 1;
            break;
          }
        }
        //end
      } else
      {
        $skip[$i] = 0;
      }
    }
    //end

    //  path
    $pu_path = '/'; //    /
    $count_sl = count($sl);
    for($i = 1; $i < $count_sl; $i++)
    {
      if($skip[$i] === 0)
      {
        $pu_path .= $sl[$i];

        if($i < ($count_sl - 1))
          $pu_path .= '/';
      }
    }
    //end

    // url
    if(isset($pu['scheme']))
      $abs = $pu['scheme'] . '://';

    $abs .= $pu['host'];

    if(isset($pu['port']))
      $abs .= ':' . $pu['port'];

    $abs .= $pu_path;

    if(isset($pu['query']))
      $abs .= '?' . $pu['query'];

    if((isset($pu['fragment'])) && ($fragment_add === 1))
      $abs .= '#' . $pu['fragment'];
    //end

    return $abs;
  }
  //end

  function mirror_link_replace($html)
  {
    $ret = $html;

    global $mirror_cfg;
    $cfg = $mirror_cfg;

    //   
    $skip = 0;

    if($cfg['skip_text'] == true)
    {
      $count_skip = count($cfg['skip']);
      for($i = 0; $i < $count_skip; $i++)
      {
        $res = strstr($ret, $cfg['skip'][$i]);

        if($res !== false)
        {
          $skip = 1;
          break;
        }
      }
    }
    //end

    if($skip === 0)
    {
      $mirror_count = count($cfg['mirror']);
  
      $res = file_get_contents($cfg['hb']['fname']);
  
    /*
      //  
      $mirror_stat['online'][]    = 0;
      $mirror_stat['time_up'][]   = 11111;
      $mirror_stat['time_down'][] = 2;
      $mirror_stat['ts'][]        = 12334545;
  
      $mirror_stat['online'][]    = 0;
      $mirror_stat['time_up'][]   = 12;
      $mirror_stat['time_down'][] = 2;
      $mirror_stat['ts'][]        = 12334545;
  
      $mirror_stat['online'][]    = 0;
      $mirror_stat['time_up'][]   = 123;
      $mirror_stat['time_down'][] = 2;
      $mirror_stat['ts'][]        = 12334545;
    print_r($mirror_stat);
    */
  
      //  
      if($res === false)
      {
        $mirror_online_count = 0; //   
      } else
      {
        $mirror_stat = unserialize($res);
  
        if($mirror_stat === false)
        {
          $mirror_online_count = 0; //-  
        } else
        {
          $mirror_online_count = $mirror_count;
  
          for($i = 0; $i < $mirror_count; $i++)
          {
            if($mirror_stat['online'][$i] === 0)
            {
              $cfg['ratio'][$i] = 0;
              $mirror_online_count--;
            }
          }
        }
      }
      //end
  
      //  
      if($mirror_online_count >= 1)
      {
        //   
        for($i = 0; $i < $mirror_count; $i++)
        {
          if(isset($mirror_ratio[$i - 1]))
            $mirror_ratio_prev = $mirror_ratio[$i - 1]; else
            $mirror_ratio_prev = 0;
  
          $mirror_ratio[$i] = $mirror_ratio_prev + $cfg['ratio'][$i];
        }
  
        $rand_res = mt_rand(1, end($mirror_ratio));
  
        //    rand
        for($i = 0; $i < $mirror_count; $i++)
        {
          if($rand_res <= $mirror_ratio[$i])
          {
            $mirror_rand = $i;
  
            break;
          }
        }
        //end
  
        $mirror = $cfg['mirror'][$mirror_rand];
        //end
  
        //
        $uri = $cfg['uri'];
        $count_uri = count($uri);
  
        //Smart replace
        if($cfg['smart_replace'] == true)
        {
          //    
          global $mirror_http_base;
  
          //    <base href...
          $res = preg_match('/<base(.*?)href="(.*?)"(.*)>/i', $ret, $m);
          if($res === 1)
            $mirror_http_base = $m[2]; else
            $mirror_http_base = 'http://' . getenv('HTTP_HOST') . getenv('REQUEST_URI');
          //end
//$mirror_http_base = 'http://torrents.saratov-style.net/forum/';
          //end
  
          $smart_count = count($cfg['smart']);
          for($i = 0; $i < $smart_count; $i++)
            $ret = preg_replace_callback($cfg['smart'][$i], 'mirror_smart_replace_callback', $ret);
        }
        //end
  
        for($i = 0; $i < $count_uri; $i++)
        {
          $from = $cfg['domain'] . $uri[$i];
          $to   = $mirror . $uri[$i];
  
          $ret = str_replace($from, $to, $ret);
        }
        //end
      }
      //end
    }

    return $ret;
  }
?>